/**********************************************************************/
/*                                                                    */
/*   Licensed Materials - Property of IBM.                            */
/*   IBM XL C/C++ for Blue Gene, V12.1                                */
/*   (5799-AG1)                                                       */
/*   Copyright IBM Corp. 2005, 2011.                                  */
/*   All Rights Reserved.                                             */
/*   US Government Users Restricted Rights -                          */
/*   Use, duplication or disclosure restricted by                     */
/*   GSA ADP Schedule Contract with IBM Corp.                         */
/*                                                                    */
/**********************************************************************/

#ifndef __IBM_VACPP_complex_h
#define __IBM_VACPP_complex_h 1

#if __cplusplus
  /* C++ */
  #if  __C99_COMPLEX_HEADER__
     #warning The <complex.h> is a deprecated header file. Use <complex> for C++ includes, or use the full path name for the C99 style complex.h
  #endif
  #include_next <complex.h>
  
#else
  /* C */
  #include_next <complex.h>
  #if __xlC__ >= 0x0800 
        __extension__ extern long double cabsl(long double  _Complex) __attribute__((__IBMBuiltin__));
        __extension__ extern float cabsf(float _Complex)  __attribute__((__IBMBuiltin__));
        __extension__ extern double cabs(double _Complex) __attribute__((__IBMBuiltin__));
  #endif
#endif

#if (((defined(__STDC_VERSION__) && (__STDC_VERSION__ >= 201000L)) || defined(__IBMCPP_COMPLEX_INIT)) && !defined(__NO_XLC_COMPLEX_INIT))
    #if defined(CMPLX)
        #undef CMPLX
    #endif
    #if defined(CMPLXF)
        #undef CMPLXF
    #endif
    #if defined(CMPLXL)
        #undef CMPLXL
    #endif

    #define CMPLX(x, y)  ((double)(x)+__I_ImaginaryOnly*(double)(y))
    #define CMPLXF(x, y) ((float)(x)+__I_ImaginaryOnly*(float)(y))
    #define CMPLXL(x, y) ((long double)(x)+__I_ImaginaryOnly*(long double)(y))
#endif

#endif
